
GammaLib - Action #3391

Implement analytical gradients for radial disk model

10/15/2020 12:27 AM - Knödlseder Jürgen

Status: In Progress Start date: 10/15/2020

Priority: Normal Due date:  

Assigned To: Knödlseder Jürgen % Done: 20%

Category:  Estimated time: 0.00 hour

Target version:    

Description

History

#1 - 10/19/2020 05:09 PM - Knödlseder Jürgen

- Status changed from New to In Progress

- Assigned To set to Knödlseder Jürgen

Code version CPU Iterations logL Speed-up Comments

Reference 35.21 2 156240.662 - -

Implementing #3203 14.81 2 156240.662 2.4 identical results

#2 - 10/20/2020 10:51 AM - Knödlseder Jürgen

- % Done changed from 0 to 20

I implemented an analytical radius gradient for the radial disk model. The table below compares the fit results to the reference results obtained with

the unmodified code. Unfortunately, this implementation leads to some convergence problems during the fit and results in inaccurate errors (see

below).

Quantity Reference value New value

Iterations 2 13

logL 156240.662 156240.584

RA 83.633218 +/- 0.000585 83.633219 +/- 0.000586

DEC 22.015370 +/- 0.000540 22.015371 +/- 0.000541

Radius 0.200600 +/- 0.000519 0.200808 +/- 1783.490243

Prefactor 5.652e-16 +/- 2.655e-18 5.654e-16 +/- 1.004e-11

Index 2.473765 +/- 0.004081 2.473796 +/- 0.004080

2020-10-20T08:28:09: +=================================+

2020-10-20T08:28:09: | Maximum likelihood optimisation |

2020-10-20T08:28:09: +=================================+

2020-10-20T08:28:12:  >Iteration   0: -logL=-156234.420, Lambda=1.0e-03

2020-10-20T08:28:15:  >Iteration   1: -logL=-156240.244, Lambda=1.0e-03, delta=5.824, step=1.0e+00, max(|grad|)=-1931.641974 [Radius:2]

2020-10-20T08:28:18:  >Iteration   2: -logL=-156240.583, Lambda=1.0e-04, delta=0.339, step=1.0e+00, max(|grad|)=-833.416297 [Radius:2]

2020-10-20T08:28:21:  >Iteration   3: -logL=-156240.609, Lambda=1.0e-05, delta=0.026, step=1.0e+00, max(|grad|)=-359.991341 [Radius:2]

2020-10-20T08:28:24:   Iteration   4: -logL=-156240.598, Lambda=1.0e-06, delta=-0.011, step=1.0e+00, max(|grad|)=-155.656673 [Radius:2] (stalled)

2020-10-20T08:28:27:   Iteration   5: -logL=-156240.589, Lambda=1.0e-05, delta=-0.009, step=1.0e+00, max(|grad|)=-67.334496 [Radius:2] (stalled)

2020-10-20T08:28:30:   Iteration   6: -logL=-156240.584, Lambda=1.0e-04, delta=-0.005, step=1.0e+00, max(|grad|)=-29.138564 [Radius:2] (stalled)

2020-10-20T08:28:33:   Iteration   7: -logL=-156240.584, Lambda=1.0e-03, delta=-0.002, step=1.0e+00, max(|grad|)=-12.618171 [Radius:2] (stalled)

2020-10-20T08:28:36:   Iteration   8: -logL=-156240.584, Lambda=1.0e-02, delta=-0.002, step=1.0e+00, max(|grad|)=-12.689130 [Radius:2] (stalled)

2020-10-20T08:28:39:   Iteration   9: -logL=-156240.584, Lambda=1.0e-01, delta=-0.002, step=1.0e+00, max(|grad|)=-13.366271 [Radius:2] (stalled)

2020-10-20T08:28:42:   Iteration  10: -logL=-156240.584, Lambda=1.0e+00, delta=-0.001, step=1.0e+00, max(|grad|)=-17.959582 [Radius:2] (stalled)
2020-10-20T08:28:45:   Iteration  11: -logL=-156240.584, Lambda=1.0e+01, delta=-0.000, step=1.0e+00, max(|grad|)=-26.278080 [Radius:2] (stalled)

2020-10-20T08:28:49:   Iteration  12: -logL=-156240.584, Lambda=1.0e+02, delta=-0.000, step=1.0e+00, max(|grad|)=-28.799630 [Radius:2] (stalled)

2020-10-20T08:28:52:   Iteration  13: -logL=-156240.584, Lambda=1.0e+03, delta=-0.000, step=1.0e+00, max(|grad|)=-29.104049 [Radius:2] (stalled)

2020-10-20T08:28:55:  Non-Positive definite curvature matrix encountered.

2020-10-20T08:28:55:  Load diagonal elements with 1e-10. Fit errors may be inaccurate.

2020-10-20T08:28:55:

2020-10-20T08:28:55: +=========================================+

2020-10-20T08:28:55: | Maximum likelihood optimisation results |

2020-10-20T08:28:55: +=========================================+

2020-10-20T08:28:55: === GOptimizerLM ===

2020-10-20T08:28:55:  Optimized function value ..: -156240.584

2020-10-20T08:28:55:  Absolute precision ........: 0.005

2020-10-20T08:28:55:  Acceptable value decrease .: 2

2020-10-20T08:28:55:  Optimization status .......: errors are inaccurate

2020-10-20T08:28:55:  Number of parameters ......: 11

2020-10-20T08:28:55:  Number of free parameters .: 7

2020-10-20T08:28:55:  Number of iterations ......: 13

2020-10-20T08:28:55:  Lambda ....................: 10000

2020-10-20T08:28:55:  Maximum log likelihood ....: 156240.584

2020-10-20T08:28:55:  Observed events  (Nobs) ...: 784398.000

2020-10-20T08:28:55:  Predicted events (Npred) ..: 784402.066 (Nobs - Npred = -4.06633628881536)

2020-10-20T08:28:55: === GModels ===

2020-10-20T08:28:55:  Number of models ..........: 2

2020-10-20T08:28:55:  Number of parameters ......: 11

2020-10-20T08:28:55: === GModelSky ===

2020-10-20T08:28:55:  Name ......................: Crab

2020-10-20T08:28:55:  Instruments ...............: all

2020-10-20T08:28:55:  Observation identifiers ...: all

2020-10-20T08:28:55:  Model type ................: ExtendedSource

2020-10-20T08:28:55:  Model components ..........: "RadialDisk" * "PowerLaw" * "Constant"

2020-10-20T08:28:55:  Number of parameters ......: 7

2020-10-20T08:28:55:  Number of spatial par's ...: 3

2020-10-20T08:28:55:   RA .......................: 83.6332186394091 +/- 0.000586190731955529 [-360,360] deg (free,scale=1)

2020-10-20T08:28:55:   DEC ......................: 22.0153707022781 +/- 0.000540656938785219 [-90,90] deg (free,scale=1)

2020-10-20T08:28:55:   Radius ...................: 0.200807514288527 +/- 1783.490242605 [0.01,10] deg (free,scale=1,gradient)

2020-10-20T08:28:55:  Number of spectral par's ..: 3

2020-10-20T08:28:55:   Prefactor ................: 5.65413711056141e-16 +/- 1.00435365485205e-11 [1e-23,1e-13] ph/cm2/s/MeV

 (free,scale=1e-16,gradient)

2020-10-20T08:28:55:   Index ....................: -2.47379598694615 +/- 0.00407993123134148 [-5,-0]  (free,scale=-1,gradient)

2020-10-20T08:28:55:   PivotEnergy ..............: 300000 [10000,1000000000] MeV (fixed,scale=1000000,gradient)

2020-10-20T08:28:55:  Number of temporal par's ..: 1

2020-10-20T08:28:55:   Normalization ............: 1 (relative value) (fixed,scale=1,gradient)

2020-10-20T08:28:55:  Number of scale par's .....: 0

2020-10-20T08:28:55: === GCTAModelCubeBackground ===

2020-10-20T08:28:55:  Name ......................: BackgroundModel

2020-10-20T08:28:55:  Instruments ...............: CTA, HESS, MAGIC, VERITAS

2020-10-20T08:28:55:  Observation identifiers ...: all

2020-10-20T08:28:55:  Model type ................: "PowerLaw" * "Constant"

2020-10-20T08:28:55:  Number of parameters ......: 4

2020-10-20T08:28:55:  Number of spectral par's ..: 3

2020-10-20T08:28:55:   Prefactor ................: 0.997042263510008 +/- 0.00227681856003367 [0.01,100] ph/cm2/s/MeV (free,scale=1,gradient)

2020-10-20T08:28:55:   Index ....................: -0.00241102099135354 +/- 0.00131525623970631 [-5,5]  (free,scale=1,gradient)

2020-10-20T08:28:55:   PivotEnergy ..............: 1000000 MeV (fixed,scale=1000000,gradient)

2020-10-20T08:28:55:  Number of temporal par's ..: 1

2020-10-20T08:28:55:   Normalization ............: 1 (relative value) (fixed,scale=1,gradient)

2020-10-20T08:28:55:

2020-10-20T08:28:55: +==============+

2020-10-20T08:28:55: | Save results |

2020-10-20T08:28:55: +==============+

2020-10-20T08:28:55:  Model definition file .....: crab_results_3391_radius.xml

2020-10-20T08:28:55:  Covariance matrix file ....: NONE

2020-10-20T08:28:55:

2020-10-20T08:28:55: Application "ctlike" terminated after 46 wall clock seconds, consuming 45.2125 seconds of CPU time.
#3 - 03/14/2022 12:26 PM - Knödlseder Jürgen

- Target version deleted (2.0.0)
